#ifndef AGDDSECTIONHH
#define AGDDSECTIONHH

namespace agdd {
  class Section;
}

#include <string>
#include <vector>
//#include "ExpatInterface/Element.h"
#include "agddAGDD.hh"
#include "agddVolume.hh"
#include "agddAttribute.hh"
#include "agddHasName.hh"
#include "agddHasTag.hh"
#include "agddKnowsDTDVersion.hh"
#include "agddBuildable.hh"

namespace agdd {

  class Section : public HasName, public KnowsDTDVersion, public Buildable {
  private:
    vector<Volume *> _baseVec;
    Attribute _version;
    Attribute _date;
    Attribute _author;
    Attribute _topVolAtt;
    Volume *  _topVolPtr;
  public:
    Section();
    virtual ~Section() {};
    void putMyselfIn(AGDD * agdd);
  public:
    void setVersion(const string & s); 
  private:
    void setDate();
  public:   
    void setAuthor(const string & authorName);  
    void setTopVol(Volume * volume); 
    void setEnvelope();
  private:
    void howToBuildMe();
  private:
    void basicBuild();
  };

} // end of agdd namespace

#endif

