#ifndef AGDDSOLIDPOSCONTAINERHH
#define AGDDSOLIDPOSCONTAINERHH

#include <string>
#include "agddPosContainer.hh"

namespace agdd {
  
  class SolidPosContainer : public PosContainer {
  private:
    string _materialName;
  public:
    virtual ~SolidPosContainer() {};
    SolidPosContainer() :
      _materialName() {};
    void setSolidPosContainerMaterialName(const string & s) {
      if (s=="") {
	cerr << "ERROR: You may not supply a blank material name " 
	     << "to setSolidPosContainerMaterialName()." << endl;
      };
      assert(s!="");
      _materialName=s;
    };
    const string getSolidPosContainerMaterialName() {
      if (_materialName=="") {
	cerr << "ERROR: You may not use getSolidPosContainerMaterialName() "
	     << "until you have set the material name." << endl;
      };
      assert(_materialName!="");
      return _materialName;
    };
  };

};

#endif
