#ifndef AGDDSUBTRACTIONHH
#define AGDDSUBTRACTIONHH

#include <vector>
#include "agddPos.hh"
#include "agddSolidPosContainer.hh"
#include "agddBooleanSolid.hh"

namespace agdd {

  class Subtraction : public BooleanSolid {
  private:
    vector<Pos *> _posVec;
  public:
    explicit Subtraction() :
      BooleanSolid("subtraction"),
      _posVec() {
    };
    ~Subtraction() {
    };
  public:
    void putMyselfIn(Section * sec) {
      assert(sec);
      // If this composition is already in a section, we need not go further.
      if (thisVolumeIsNotInSomeSection()) {
	cout << "Creating a " << flush << getTag()
	     << " named " << flush << getName() 
	     << " ... " << endl;
	makeTheElement();
	putThisVolumeElementIntoThisSection(theElement(), sec);
	doBooleanSolidThingsToThisElement(theElement()); 
	setSolidPosContainerMaterialName(getMaterialName());
	// Now we need to put in the poses.
	{
	  for (unsigned int i=0; i<_posVec.size(); i++) {
	    _posVec[i]->putMeInThisSolidPosContainer(this);
	  }
	} 
	cout << "done." << endl;
      }      
    };
    void addSolidPos(Pos * pos) {
      _posVec.push_back(pos);
    };
  };

} // end of namespace

#endif
